FROM offlineinternet/olip-base:latest as build

RUN apt update && \
    apt install -y build-essential cmake libaio-dev libncurses5-dev gnutls-bin gcc make bison openssl g++ gnutls-dev && \
    rm -rf /user/local/*

WORKDIR /opt

RUN git clone https://github.com/MariaDB/server.git mariadb && \
	cd mariadb && \
	git checkout mariadb-10.2.39

RUN cd mariadb && \
	cmake . -DPLUGIN_AUTH_PAM=NO -DPLUGIN_AUTH_PAM_V1=NO && \
	make -j$(getconf _NPROCESSORS_ONLN)

RUN cd mariadb && \
	make install

FROM offlineinternet/olip-base:latest

RUN rm -rf /user/local/*

WORKDIR /usr/local/

COPY --from=build /usr/local/mysql/ mysql/

# add our user and group first to make sure their IDs get assigned consistently, regardless of whatever dependencies get added
RUN groupadd -r mysql && useradd -r -g mysql mysql

# https://bugs.debian.org/830696 (apt uses gpgv by default in newer releases, rather than gpg)
RUN set -ex; \
	apt-get update; \
	if ! which gpg; then \
		apt-get install -y --no-install-recommends gnupg; \
	fi; \
	if ! gpg --version | grep -q '^gpg (GnuPG) 1\.'; then \
# Ubuntu includes "gnupg" (not "gnupg2", but still 2.x), but not dirmngr, and gnupg 2.x requires dirmngr
# so, if we're not running gnupg 1.x, explicitly install dirmngr too
		apt-get install -y --no-install-recommends dirmngr; \
	fi; \
	rm -rf /var/lib/apt/lists/*

# add gosu for easy step-down from root
# https://github.com/tianon/gosu/releases
ENV GOSU_VERSION 1.12
RUN set -eux; \
	apt-get update; \
	DEBIAN_FRONTEND=noninteractive apt-get install -y --no-install-recommends ca-certificates; \
	savedAptMark="$(apt-mark showmanual)"; \
	apt-get install -y --no-install-recommends wget; \
	rm -rf /var/lib/apt/lists/*; \
	dpkgArch="$(dpkg --print-architecture | awk -F- '{ print $NF }')"; \
	wget -O /usr/local/bin/gosu "https://github.com/tianon/gosu/releases/download/$GOSU_VERSION/gosu-$dpkgArch"; \
	wget -O /usr/local/bin/gosu.asc "https://github.com/tianon/gosu/releases/download/$GOSU_VERSION/gosu-$dpkgArch.asc"; \
	export GNUPGHOME="$(mktemp -d)"; \
	gpg --batch --keyserver hkps://keys.openpgp.org --recv-keys B42F6819007F00F88E364FD4036A9C25BF357DD4; \
	gpg --batch --verify /usr/local/bin/gosu.asc /usr/local/bin/gosu; \
	gpgconf --kill all; \
	rm -rf "$GNUPGHOME" /usr/local/bin/gosu.asc; \
	apt-mark auto '.*' > /dev/null; \
	[ -z "$savedAptMark" ] || apt-mark manual $savedAptMark > /dev/null; \
	apt-get purge -y --auto-remove -o APT::AutoRemove::RecommendsImportant=false; \
	chmod +x /usr/local/bin/gosu; \
	gosu --version; \
	gosu nobody true

RUN mkdir /docker-entrypoint-initdb.d

RUN set -ex; \
	apt-get update; \
	DEBIAN_FRONTEND=noninteractive apt-get install -y --no-install-recommends \
		pwgen \
		tzdata \
		xz-utils \
		zstd \
		libaio1 \
		libaio-dev \
	; \
	rm -rf /var/lib/apt/lists/*; \
	mkdir -p /data/mariadb /var/run/mysqld; \
	chown -R mysql:mysql /data/mariadb /var/run/mysqld; \
	chmod 777 /var/run/mysqld

EXPOSE 3306

COPY entrypoint.sh /

ENTRYPOINT ["/entrypoint.sh"]
CMD ["mysqld", "--datadir=/data/mariadb"]